// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\bomb.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Sunday, September 02, 2007 3:46 PM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Aqui manejamos las funciones de la 
//                    : bomba tranquilizadora y de las particulas. 
//                    :  
// ============================================================


// Cuando se sale de los limites
function bomb::onWorldLimit(%this, %mode, %limit) {

   // Cuando llega al suelo
   if (%limit $= "bottom") {
      // Sonido
      alxStop(%this.fallingSound);
      alxPlay(bombExplosion);
      alxPlay(flowerShower);

      // Explosion
      %effect = new t2dParticleEffect() { 
         scenegraph = %this.sceneGraph;
         class = "flowerExplosion";
      };
      %effect.loadEffect( "~/data/particles/flowerExplosion.eff" );
      %effect.setPositionX( %this.getPositionX() );
      %effect.setPositionY( %this.getPositionY() );
      %effect.playEffect();

      // Quitamos la bomba
      %this.safeDelete();

      // Ya no se lastiman
      $activeCollisions= false;
      %count= $currentLevel.pedestrianSet.getCount();
      for (%i = 0; %i < %count; %i++) {
         %currPed= $currentLevel.pedestrianSet.getObject(%i);
         if ((%currPed.getAnimationName() $= "guyFightingAnimation") || 
             (%currPed.getAnimationName() $= "guyPissedAnimation")) {
            %currPed.playAnimation( "guySurprisedAnimation" );
         }
      }
   }
}


// Cuando empieza a caer la bomba
function bomb::falling(%this) {
   %this.fallingSound= alxPlay(bombWhistle);
   %this.schedule(50, decreaseSize);
}


// Cuando empieza a caer la bomba
function bomb::decreaseSize(%this) {
   if (!$gamePaused) {
      %this.setSizeX( %this.getSizeX() -0.5);
      %this.setSizeY( %this.getSizeY() -0.5);
   }
   %this.schedule(50, decreaseSize);
}


// Cuando termina el efecto de explosion
function flowerExplosion::onStopEffect(%this) {
   // Nos deshacemos del effecto
   %this.safeDelete();
   
   // Reactivamos las bombas
   $bombActive= false;
   $activeCollisions= true;
}