// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\crabLevel.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Sunday, August 19, 2007 7:33 PM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Manejamos los datos del nivel.
//                    :  
//                    :  
// ============================================================

$playerBombs= 3;
$maxLayers= 4;
$maxVel= 12;
$minVel= 6;
$minPositionY= 16.5;
$maxPositionY= 31.0;
$percentIncVel= 30;
$respawnTime= 2000;
$minimumRespawnTime= 1250;
$deltaRespawnTime= 15;


// Al iniciar el nivel
function crabLevel::onLevelLoaded(%this) {
   // Musica maestro
   alxStop($song);
   $song = alxPlay(levelAudio);
   //schedule(50, alxPlay, flowerShower);
   alxPlay(flowerShower);

   // Creamos una variable global para acceder al nivel
   $currentLevel= %this;
   
   // Limpiamos algunas variables globales
   $gamePaused= false;
   $sideCount= 0;
   
   // Reiniciamos texto
   %this.angryCount= 0;
   %this.angryPercent= 0;
   %this.bestTime= $scoreTable.Scores.getObject(0).PlayerScore;
   percentText.text= "0.00%";
   %minutes= mFloor( %this.bestTime/ 60 );
   %seconds= %this.bestTime % 60;
   bestTimeText.text= %minutes @ ":" @ ((%seconds < 10) ? ("0") : ("")) @ %seconds;
   
   // Hacemos "blinding" al boton que sirve para poner pausa
   moveMap.bindCmd(keyboard, "p"  , "" , "pauseGame($currentLevel);" );
   moveMap.bindCmd(keyboard, "escape"  , "" , "pauseGame($currentLevel);" );
   
   // Hacemos "blinding" al boton que sirve para tirar bombas
   moveMap.bindCmd(keyboard, "space"  , "" , %this @ ".dropDaBomb();" );
   
   // Manejamos a las personas en un conjunto
   $activeCollisions= true;
   %this.pedestrianSet = new SimSet();
   $newGuySchedule= %this.schedule(250, createNewPedestrian);

   //%this.setBlendAlpha(0);
   //%this.fadeFast(1, 2000);
}


// Cada que se actualiza la escena
function crabLevel::onUpdateScene(%this) {
   // Si la escena esta en pausa no actualizamos
   if ($gamePaused) {
      return;
   }

   // Actualizamos el texto del reloj
   %currentTime= mFloor( %this.getSceneTime() );
   %minutes= mFloor( %currentTime / 60 );
   %seconds= %currentTime % 60;
   clockText.text= %minutes @ ":" @ ((%seconds < 10) ? ("0") : ("")) @ %seconds;
   %this.time= %currentTime;
   
   // Mejor tiempo
   if (%this.bestTime< %currentTime) {
      %this.bestTime= %currentTime;
      bestTimeText.text= clockText.text;
   }
   
   // Tiempo transcurrido
   %elapsedTime= %this.getSceneTime() -$lastTime;
   $lastTime= %this.getSceneTime();
   
   // No se debería de necesitar, pero para evitar broncas
   if (%this.angryCount< 0) {
      echo ("Check the AngryCount!");
      %this.angryCount= 0;
   }
   
   // Actualizamos el porciento en base al tiempo y a un factor determinado
   if (!$gamePaused) {
      %this.angryPercent+= %this.angryCount*($percentIncVel*%elapsedTime);
   }
   if (%this.angryPercent >= 10000) {
      // Ya nos pasamos, ponemos pantalla de Game Over
      %this.angryPercent= 10000;
      %this.gameOver();
   }
   %scrollVelX= 0.5 + %this.angryPercent/400;
   cloudsScroll.setScroll(%scrollVelX SPC "0");

   // Actualizamos el texto del porciento
   %percentInt= mFloor(%this.angryPercent/100);
   %percentDec= %this.angryPercent % 100;
   percentText.text= %percentInt @ "." @ ((%percentDec<10) ? ("0") : ("")) @ %percentDec @ "%";
}


// Al perder
function crabLevel::gameOver(%this) {
   // Detemos y ponemos el sonido
   $gamePaused= true;
   setGamePaused(1);
   alxStopAll();
   alxPlay(gameOver);
   
   // Ponemos la imagen y le decimos que mande a llamar el dialogo despues
   gameOverPic.setVisible(true);
   gameOverPic.setBlendAlpha(0.2);
   gameOverPic.fadeFast(1, 2000, "gameOverGui(" @ $currentLevel @ ");");

   //gameOverGui(%this);
}


// Al salir del nivel
function crabLevel::onLevelEnded(%this) {

   // Nos deshacemos de la lista de peatones
   %count= %this.pedestrianSet.getCount();
// TODO: Ver porque no se estan borrando bien (aunque no creo que se necesite)   
/*
   for (%i = 0; %i < %count; %i++) {
      %this.pedestrianSet.remove( %this.pedestrianSet.getObject(%i) );
   }
*/
   %this.pedestrianSet.delete();
}


// Metemos otro cuate a la escena
function crabLevel::createNewPedestrian(%this) {
   // Si esta la bomba, mejor que no salgan (para que no se junten muchos luego)
   if ($bombActive){
      $newGuySchedule= %this.schedule($respawnTime, createNewPedestrian);
      return;
   }
   
   // Escojemos de que lado sale, cuidando que no se cargue mucho a ninguno de los dos
   %side = getRandom(1);
   $sideCount+= (%side == 0) ? (-1) : (1);
   if ($sideCount> 2) {
      %side= 0;
      $sideCount-= 2;
   }
   if ($sideCount< -2) {
      %side= 1;
      $sideCount+= 2;
   }
      
   // Vemos a que altura salen y con que velocidad
   %layer = getRandom($maxLayers -1);
   %velocityX= getRandom(100*$minVel, 100*$maxVel)/100;
   if (%side == 0) {
      %velocityX= -%velocityX;
   }
   %positionX= (%side == 0) ? (60) : (-60);
   %positionY= $maxPositionY - ($maxPositionY -$minPositionY)*(%layer/$maxLayers);

   // Lo creamos
   %newGuy = new t2dAnimatedSprite() {
      sceneGraph = %this;
      class = "pedestrian";
      layer = %layer;
      size = "8.25 18.75";
      collisionActiveReceive= true;
      collisionActiveSend= true;
      collisionCallback= true;
      collisionPhysicsSend= false;
      collisionPhysicsReceive= false;
      collisionDetectionMode= "FULL";
      collisionResponseMode= "CLAMP";
      useMouseEvents= true;
      visible= true;
   };

   // Le asignamos sus valores iniciales
   %newGuy.playAnimation("guyWalkingAnimation");
   %newGuy.setPosition(%positionX SPC %positionY);
   %newGuy.setLinearVelocity(%velocityX SPC "0");
   %newGuy.setWorldLimit("NULL", "-65 -40 65 40", true);
   %newGuy.setCollisionPolyCustom(4, "-0.6 -1.0 0.6 -1.0 0.6 1.0 -0.6 1.0");
   %newGuy.setCollisionLayers(%layer);
   if (%side == 0) {
      %newGuy.setFlipX(true);
      %newGuy.exitSide= "left";
   } else {
      %newGuy.exitSide= "right";
   }
   
   // Lo agregamos al conjunto
   %this.pedestrianSet.add(%newGuy);
   
   // Vemos cuando ponemos otro
   $respawnTime-= $deltaRespawnTime;
   if ($respawnTime< $minimumRespawnTime) {
      $respawnTime= $minimumRespawnTime;
   }
   $newGuySchedule= %this.schedule($respawnTime, createNewPedestrian);
}


// Nuke 'em!
function crabLevel::dropDaBomb(%this) {
   //Nos fijamos que no hayan tirado alguna antes y que todavia tenga
   if (($bombActive) || ($playerBombs<= 0) || ($gamePaused)){
      return;
   }
   $bombActive= true;

   // Quitamos un icono
   %icon= "bombIcon_" @ $playerBombs;
   %icon.safeDelete();
   $playerBombs--;

   // La creamos
   %newBomb= new t2dAnimatedSprite() {
      sceneGraph = %this;
      class = "bomb";
      layer = 10;
      size = "30 30";
      visible= true;
   };

   // Le asignamos sus valores iniciales
   %newBomb.playAnimation("bombAnimation");
   %newBomb.setPosition("0 -15");
   %newBomb.setConstantForce("0 250", true);
   %newBomb.setImpulseForce("0 -25", true);
   %newBomb.setWorldLimit("NULL", "-50 -50 50 25", true);

   // Sonido de que la aventamos y programos el sonido de que cae
   alxPlay(bombThrow);
   %newBomb.schedule(150, falling);
}