//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------


//---------------------------------------------------------------------------------------------
// startGame
// All game logic should be set up here. This will be called by the level builder when you
// select "Run Game" or by the startup process of your game to load the first level.
//---------------------------------------------------------------------------------------------
function startGame(%level) {
   // 
   exec("~/gui/gameOver.gui");
   exec("~/gui/pauseScreen.gui");
   exec("~/gui/highScoresNotification.gui");

   // 
   exec("./bomb.cs");
   exec("./crabLevel.cs");
   exec("./pedestrian.cs");
   exec("./sun.cs");

   Canvas.setContent(mainScreenGui);
   //Canvas.setCursor(DefaultCursor);
   //Canvas.setCursor(CustomCursor);

   new ActionMap(moveMap);   
   moveMap.push();

   $enableDirectInput = true;
   activateDirectInput();
   enableJoystick();

   sceneWindow2D.loadLevel(%level);
}


//---------------------------------------------------------------------------------------------
// endGame
// Game cleanup should be done here.
//---------------------------------------------------------------------------------------------
function endGame() {
   sceneWindow2D.endLevel();
   moveMap.pop();
   moveMap.delete();
}
