// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\pedestrian.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Tuesday, August 28, 2007 8:55 AM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Manejamos las funciones de los monitos.
//                    :  
//                    :  
// ============================================================


// Cuando chocan
function pedestrian::onCollision (%srcObj, %dstObj, %srcRef, %dstRef, %time, %normal, %contactCount, %contacts) {
//echo (%contacts SPC %time SPC ";" SPC %srcObj.layer SPC %dstObj.layer);
//echo (%srcObj.getPositionX() SPC %dstObj.getPositionX());
//echo (%srcObj.getCollisionMasks() SPC %dstObj.getCollisionMasks());
   //
   if (!$activeCollisions) {
      return;
   }

   // Si choca con otro cuate
   if ( %srcObj.getAnimationName() $= "guyWalkingAnimation") {
      // Si es el mismo de antes no buscamo pleito
      if ((%srcObj.collidedWith == %dstObj) && (%dstObj.collidedWith == %srcObj)){
         return;
      }
      
      // Si estan fuera de la pantalla, tampoco
      if ( (mAbs(%srcObj.getPositionX()) > 48) || (mAbs(%dstObj.getPositionX()) > 48) ) {
         return;
      }

      // Acomodamos al mono para que deje de colisionar
      if (%time< 0) {
         %time= 0;
      }
      %srcObj.setPositionX( %srcObj.getPositionX() - 1.5*%time*%srcObj.getLinearVelocityX() );

      // Si el otro ya se esta peleando, suelta al otro y empieza una nueva
      if ((%dstObj.getAnimationName() $= "guyFightingAnimation") ||
          ((%dstObj.getAnimationName() $= "guyPissedAnimation") && (%dstObj.collidedWith != %srcObj)) ) {
         // El otro se va feliz
         %other = %dstObj.collidedWith;
         %other.playAnimation( "guySurprisedAnimation" );
         // Nuevos valores del cuate
         %dstObj.collidedWith = %srcObj;
         %dstObj.setFlipX( !%dstObj.getFlipX() );
         %dstObj.returnVelocityX = -%dstObj.returnVelocityX;
         %dstObj.playAnimation( "guyPissedAnimation" );
      }

      // Determinamos por donde se regresan y hace donde miran
      if (%srcObj.getPositionX() < %dstObj.getPositionX() ) {
         %srcObj.returnVelocityX= -mAbs(%srcObj.getLinearVelocityX()); 
         %srcObj.setFlipX( false );
      } else {
         %srcObj.returnVelocityX= mAbs(%srcObj.getLinearVelocityX());
         %srcObj.setFlipX( true );
      }
      
      // Valores para manejar el pleito
      alxPlay(fightStart);
      %srcObj.collidedWith= %dstObj;
      %srcObj.setLinearVelocity("0 0");
      %srcObj.playAnimation( "guyPissedAnimation" );
      $currentLevel.angryCount++;
   }
}


// Cuando se termina la animacion
function pedestrian::onAnimationEnd (%this) {
   // Ya se enojaron, ¡a pelear!
   if (%this.getAnimationName() $= "guyPissedAnimation") {
      %this.playAnimation( "guyFightingAnimation" );
      %this.setAnimationFrame( getRandom(1) );
   } else
   // Ya se contentaron, que se regresen
   if (%this.getAnimationName() $= "guySurprisedAnimation") {
      %this.setFlipX( !%this.getFlipX() );
      %this.setLinearVelocityX( %this.returnVelocityX );
      %this.playAnimation( "guyWalkingAnimation" );
      $currentLevel.angryCount--;
   } 
}


// Al presionarlos
function pedestrian::onMouseDown(%this, %modifier, %worldPosition, %mouseClicks) {
   // Si se está peleando, los separamos
   if ((%this.getAnimationName() $= "guyFightingAnimation") || 
       (%this.getAnimationName() $= "guyPissedAnimation")) {
      //alxPlay(fightOver);
      alxPlay(fightOver);
      %this.playAnimation( "guySurprisedAnimation" );
      %other= %this.collidedWith;
      %other.playAnimation( "guySurprisedAnimation" );
   }
}


// Si se salen, los borramos
function pedestrian::onWorldLimit(%this, %mode, %limit) {
   if (%limit $= %this.exitSide) {
      $currentLevel.pedestrianSet.remove(%this);
      %this.safeDelete();
   }
}