//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------

$gameName= "Mi Pueblito";
// Imagen del cursor
new GuiCursor(CustomCursor) {
   hotSpot = "4 4";                             // Coordinadas X/Y del donde hace "click"
   bitmapName = "~/data/images/pointer.png";
};


//---------------------------------------------------------------------------------------------
// initializeProject
// Perform game initialization here.
//---------------------------------------------------------------------------------------------
function initializeProject() {
   // Cargamos los GUI
   exec("~/gui/profiles.cs");
   exec("~/gui/mainScreen.gui");
   exec("~/gui/mainMenu.gui");
   exec("~/gui/ggLogo.gui");
   exec("~/gui/guillenLogo.gui");
   exec("~/gui/oscarCredit.gui");
   exec("~/gui/pierCredit.gui");
   exec("~/gui/chrisCredit.gui");
   exec("~/gui/highScoresScreen.gui");
   exec("~/gui/instructions.gui");

   // Ejecutamos los scripts
   exec("./gameScripts/fade.cs");
   exec("./gameScripts/game.cs");
   exec("./gameScripts/highScores.cs");
   exec("./gameScripts/audioDatablocks.cs");

   // 
   sceneWindow2D.setUseWindowMouseEvents(true);
   canvas.setCursor(CustomCursor);
   
   // Cargamos la tabla de scores
   $scoreTable= NewHighScores();
   //$scoreTable.createDefaultTable();
   //$scoreTable.save("./gameScripts/score.cs");
   $scoreTable.load("game/gameScripts/score.cs.dso");
   //$scoreTable.debug();

   // This is where the game starts. Right now, we are just starting the first level. You will
   // want to expand this to load up a splash screen followed by a main menu depending on the
   // specific needs of your game. Most likely, a menu button will start the actual game, which
   // is where startGame should be called from.
   //startGame( expandFilename($Game::DefaultScene) );
   //loadMenuScreen();

   //toggleFullScreen();
   loadGGSplash();
}

//---------------------------------------------------------------------------------------------
// shutdownProject
// Clean up your game objects here.
//---------------------------------------------------------------------------------------------
function shutdownProject() {
   $scoreTable.save("game/gameScripts/score.cs.dso");
   endGame();
}

//---------------------------------------------------------------------------------------------
// setupKeybinds
// Bind keys to actions here..
//---------------------------------------------------------------------------------------------
function setupKeybinds() {
   new ActionMap(moveMap);
   //moveMap.bind("keyboard", "a", "doAction", "Action Description");
}
